/*
 * AVR_Sensor_Kit_Thermopile_Amplifier.c
 *
 * Created: 2020-06-09 오전 11:33:58
 *  Author: 강건일
 200609 : TIR128B 에서 수정 보완
 *. CIRCUIT : AVR Sensor kit
    PCB : Atmega128 Sensor R1 191022
*. TP2 출력 : PF2 (ADC2)
*. Thermioster 출력 : PF3 (ADC3 )  

180405 ~ : 거리 확장을 위한 실험.
실험 : 변화가 있으면 stdby 가 아님으로 하고 , stdby tp2 기준으로 변화분 전압 검출 판정.---변수는 stdbytp2
180410 : THG 에 47uF add, 2nd amp : from 100k to 120k, on : 10 off :8, delay :800

180517 :
거리확장 : fresnel Lens 5088 사용----3.5M 동작
이중 감지에서 앞쪽 감지 사라질때 인식 안되는 문제 ----delta volt 방법으로는 안됨.
TP2 출력으로 delay ref 만들어서 비교 값으로 확인
수정 : tp2 : 10k x 4.7uF ----> adc2
dly ref : 20k x 47uF-----adc0 , 47k x 47uF
reset signal active Low -----PB7

180530 : tp2 와 blind tp2 신호를 이용하여 실시간 감지로 인지 확인 출력
*.filter : 10 x 4.7uF
*. blind tp2 : adc0, tp2 : adc2.
180605 : tp2dif 값을 안정화 시키기위한 보완
180607 : 처음 stdby 에서 red on 되면 다시 pwr on 해야함. yel 가 on 되어야 정상 동작 됨
(TP2 의  filter ckt : 14.7 uF * 10k)
180614~ : INT0 추가하여 동작중에 dif1 값을 다시 설정 한다.
//180607 10개로 평균내고 마지막11번째는 최종 값 표기
// 20일때 동작 잘 안됨 .
//180607  +30 에서 감지 실험, pwr on 후 환경 적응 최소 3분 필요
//180607  TP2bld 가 TP2 보다 크면 GRN LED on 한다.
//180619  인터럽 값으로 판정
//180621 : 인터럽 후 10번 읽은 값으로 기록되므로 감지 시간을 빠르게 수정
//180704 : 기준값 보다 50 yel on, 100 크면 red on, 150 크면 grn on, 200크면 blu on
//180706 : INT1 을 끄고(high), 전원을 인가한다.그리고 INT1 을 켜면 delay 동작.
INT0 동작시 delay 동작 없이 dif1 이 update 된다.
180716 : int0은 push sw 사용하고 low 로 동작 시킴, dif1 사용. 이따금 엉킴 발생.
int1은 slide sw 사용하고, falling edge 사용, display delay.
180719 : int1 : 회로 변경 from slide switch to TR ckt, 약 1400ms 후동작(47uF)
//180719 : 0704 뺄셈에서 비율 변경으로 수정
//180802 : 0719에서 연산 방식 변경
//180828 : bldy1 과 tp2x1 값을 INT0 으로 읽어서 비율로 연산하여 tp2x2을 산출한다.
//180903 : 뺄셈으로 변경 ( 비율 곱셈 방식에서 온도 변화시 혼자 켜짐 발생)
//180905 : 비율로하고 offset 15를 더한다.
//180907 : 높은 온도에서 낮아질때, 혼자 켜짐 보상

200507 : IR115-RIN-R1 보드와 회로에서 수정하여, 개발용 보드로 사용
*. PF1 ( Pin 60)----TC1047A 출력의 입력으로 주변 온도 읽기
*. PF2 ----TIR16B / TIR-INT8M Amplifier 의 TP2 출력의 입력
*. PD0 ----push switch 로 주변 온도 읽는다.
*. PB0 ----Active Low, TP2 읽는 주기를 표시.
*. PB3-----Active low, OUT 검출 출력
*. PB4 ~ PB7  = Yel, PB5 = Red, PB6 = Grn , PB7 = Blue
*. PB0(pin10)-----감지 검출 주기 표시 led, Active LOw

*. 문제점 : else if 문으로 할때 검출 출력 led 표기 안된다.
200508 : TIR16B (열 보상회로 내장) 적용시, +12 , -10 적용 실험---- 이 값이 작아지면 혼자 켜짐현상 발생
200522 : test board 용으로 수정 , CKT : TIR128B
200527 ; 문제점 보완 실험 : 초기에 검출 led 켜짐 오동작,

200609 : TIR128B에서 AVR Sensor Kit 로 변경
*.LCD 사용시, LCD 동작에따른 지연 현상이 발생되므로, delay 800 을 재 조절해야함.

*/

#include <stdio.h>
#include <avr/io.h>
#include <math.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "iseg7.cpp"
#include "iseg7 source.c"   //추가해야 동작됨
#include "button123.cpp"    // 추가해야  PD0 스위치 동작 잘됨
#include "button switch123.c"
#include "lcdh.cpp"
#include "lcd.c"

#define  N_CHANNEL   4           // 채널 읽기from 4
#define  setup   100            // 온도 안정화setup 반복, 시간이 길어야 pcb 내 온도가 안정 됨,

static int i;
static int k;

static int ref11;
static int ref21;
static int ref31;
static int ref211;

static unsigned int adresult[4] ;  //인터럽시 값

void msec_delay (int n);

int main(void)

{

int j; // 온도 setup delay
int adresult[N_CHANNEL];           // 처리 속도 개선
int i; 		 //for 문
int k;      // TP2 평균값 용
long int  ref0, ref1, ref2, ref3,ref31,ref4,ref01, ref11,ref21,ref211,Temp, tp2, Stdby0, Stdby1, Stdby, DV ;

ref0, ref1, ref2, ref3,ref31,ref4,ref01, ref11,ref21,ref211,Temp, tp2, Stdby0, Stdby1, Stdby, DV = 0 ; //clear
// 변수 추가, ref 는 기준값 변수

DDRA = 0xFF; //PORT A 를 출력 포트
DDRC = 0xFF ; // PORC 를 출력 포트
DDRB = 0xFF; // PORT B를 출력 포트
DDRD = 0xF0; // PORT D 상위 출력 포트, 하위 4 bit 는 입력포트

PORTA = 0x00; //seg L= on
PORTD = 0x00; //digit L = on
msec_delay(80000); // 약 5000ms on

sei ();

ISeg7Init();

for ( j=0; j<setup ;j++)  // 온도 회로 setup 지연 함수

{

while ( ( ~ PIND & 0b00000001))  //PD0 (INT0 스위치)이 눌리면 (High---> low)이면 기존 program이 stop 되고 DV 값 표기

{
	ISeg7DispNum (tp2,10) ;

	PORTB = 0b00001110; // 개별 LED 5개 on  Active low,800 = 50ms 주기
	//PORTA = 0x00; //seg L= on
	//PORTD = 0x00; //digit L =on
	msec_delay(800); // 약 50ms on	Based on 16Mhz CLK
	
	PORTB = 0b11111110; // 개별 LED 5개 on // Active low
	//PORTA = 0x00; //seg L= on
	//PORTD = 0x00; //digit L =on
	msec_delay(800); // 약 50ms on	Based on 16Mhz CLK

	}

sei ();

ISeg7Init();

ADCSRA = (1<<ADEN) | (7<<ADPS0) ;
//  프리스켈러 분주 = 128, smpling rate=> 16MHz / 128 = 125 KHz  /13 clock =9.6KHz
// 200528 : 초기에 DV 오동작과 감지 led 켜짐 보완을 위해 Analog 읽기 추가
for ( i=0; i<N_CHANNEL;i++)
{
ADMUX = (1<<REFS0) | (i<<MUX0) ;  // 내부2.56v 일때3 그리고 5v일때는 1임, .
//실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨

ADCSRA |= (1<<ADSC) ; // AD 변환 시작

while(!(ADCSRA & (1<<ADIF))) ; //변환 종료를 기다림

ADCSRA |= (1<<ADIF) ; // ADIF 플레그 지움
adresult[i] = ADC ;

adresult[i] = adresult[i] * 5 ;
//실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
//이것을 실제 전압 mv로 만들기 위해 *5 함

ref31=  adresult[3];  // thermister

ref21 =  adresult[2];  // FP2 ,Tp2 2차 amp 출력 값,

ref11=  adresult[1];  // SPL for voice, NC

ref01 =  adresult[0];  // SVR

}

tp2 = (ref21 + ref211 ) / 2 ; // 실시간 tp2 값


if ((ref211 - 0) >= adresult[2]) // 먼저 값보다 현재 값이 작으면 감지 사라짐 의미

{
Stdby0 = adresult[2] ;
Stdby = (Stdby0 + Stdby1) / 2 ;

}

else
{
tp2 = adresult[2] ;

}

if ( tp2 >= (Stdby + 0))
{
DV = tp2 - Stdby ;
}

else
{
DV = 0 ;
PORTB = 0b11111110 ; // all led off, relay off

}

ISeg7DispNum (ref31,10) ; // 실시간 값

if ( DV >= 80)
{
PORTB = 0b00000000 ;
}

else if ( DV >= 40)
{
PORTB = 0b10000000 ;
}

else if ( DV >= 20)
{
PORTB = 0b11000000 ;
}

else if ( DV >= 10)
{
PORTB = 0b11100001 ;
}

else
{
PORTB = 0b11111110 ; // 10 이하일때 PB3 = high
}

msec_delay(800) ;	// 50ms 지연

for ( i=0; i<N_CHANNEL;i++)
{
ADMUX = (1<<REFS0) | (i<<MUX0);  // 내부2.56v 일때3 그리고 5v일때는 1임, .
//실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨

ADCSRA |= (1<<ADSC); // AD 변환 시작

while(!(ADCSRA & (1<<ADIF))); //변환 종료를 기다림

ADCSRA |= (1<<ADIF); // ADIF 플레그 지움
adresult[i] = ADC;

adresult[i] = adresult[i] * 5 ;
//실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
// 이것을 실제 전압 mv로 만들기 위해 *5 함

 ref31=  adresult[3];  // thermister

ref211 =  adresult[2];  // FP2 ,Tp2 2차 amp 출력 값,

ref11 =  adresult[1];  // SPL for voice , NC

ref01 =  adresult[0];  // SVR

}

tp2 = (ref21 + ref211 ) / 2 ; // 실시간 tp2 값


if ((ref21 - 0) >= adresult[2]) // 먼저 값보다 현재 값이 작으면 감지 사라짐 의미

{
Stdby1 = adresult[2] ;
Stdby = (Stdby0 + Stdby1) / 2 ;
}

else
{
tp2 = adresult[2] ;

}

if ( tp2 >= (Stdby + 0))
{
DV = tp2 - Stdby ;

}

else
{
DV = 0 ;
PORTB = 0b11111110 ; // all led off
}

ISeg7DispNum (ref31,10) ; // 실시간 값


if ( DV >= 80)
{
PORTB = 0b00000000 ;
}

else if ( DV >= 40)
{
PORTB = 0b10000000 ;
}

else if ( DV >= 20)
{
PORTB = 0b11000000 ;
}

else if ( DV >= 10)
{
PORTB = 0b11100000 ;
}

else
{
PORTB = 0b11111110 ; //10 이하일대 PB3 은 high, relay off
}

msec_delay(800) ;	// 50ms 지연

}


while (1)  // TP2 실제 동작

{

while ( ( ~ PIND & 0b00000001))  //PD0 (INT0 스위치)이 눌리면 (High---> low)이면 기존 program이 stop 되고 DV 값 표기

 {

ISeg7DispNum (DV,10) ;

PORTB = 0b00001110; // 개별 LED 5개 on // Active low
PORTA = 0x00; //seg L= on
PORTD = 0x00; //digit L =on

msec_delay(800); // 약 50ms on	Based on 16Mhz CLK

ISeg7DispNum (DV,10) ;

PORTB = 0b111111110; // 개별 LED 5개 off
PORTA = 0x00; //seg L= on
PORTD = 0x00; //digit L =on

msec_delay(800); // 약 50ms on

}


// 여기부터 기본 TP2 전압 측정과 감지 출력 표시

//data += 10; // 10에서 1로 변경 10은 10자리부터 시작되고 1은 첫 자리부터 시작.

for ( i=0; i<N_CHANNEL;i++)
{
ADMUX = (1<<REFS0) | (i<<MUX0) ;  // 내부2.56v 일때3 그리고 5v일때는 1임, .
//실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨

ADCSRA |= (1<<ADSC) ; // AD 변환 시작

while(!(ADCSRA & (1<<ADIF))) ; //변환 종료를 기다림

ADCSRA |= (1<<ADIF) ; // ADIF 플레그 지움
adresult[i] = ADC ;

adresult[i] = adresult[i] * 5 ;
//실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
//이것을 실제 전압 mv로 만들기 위해 *5 함

 ref31=  adresult[3];  // thermister

ref21 =  adresult[2];  // FP2 ,Tp2 2차 amp 출력 값,

ref11=  adresult[1];  // SPL for voice, NC

ref01 =  adresult[0];  // SVR, NC

}

tp2 = (ref21 + ref211 ) / 2 ; // 실시간 tp2 값


if ((ref211 - 10) >= adresult[2]) // 먼저 값보다 현재 값이 작으면 감지 사라짐 의미

{
Stdby0 = adresult[2] ;
Stdby = (Stdby0 + Stdby1) / 2 ;

}

else
{
tp2 = adresult[2] ;

}

if ( tp2 >= (Stdby + 10))
{
DV = tp2 - Stdby ;
}

else
{
DV = 0 ;
PORTB = 0b11111110 ; // Yel LED 만 on

}

ISeg7DispNum (tp2,10) ; // 실시간 값

if ( DV >= 80)
{
PORTB = 0b00000001 ;
}

else if ( DV >= 40)
{
PORTB = 0b10000001 ;
}

else if ( DV >= 20)
{
PORTB = 0b11000001 ;
}

else if ( DV >= 10)
{
PORTB = 0b11100001 ;
}

else
{
PORTB = 0b11111110 ; // 10 이하일때 PB3 = high
}

msec_delay(800) ;	// 50ms 지연


for ( i=0; i<N_CHANNEL;i++)
{
ADMUX = (1<<REFS0) | (i<<MUX0);  // 내부2.56v 일때3 그리고 5v일때는 1임, .
//실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨

ADCSRA |= (1<<ADSC); // AD 변환 시작

while(!(ADCSRA & (1<<ADIF))); //변환 종료를 기다림

ADCSRA |= (1<<ADIF); // ADIF 플레그 지움
adresult[i] = ADC;

adresult[i] = adresult[i] * 5 ;
//실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
// 이것을 실제 전압 mv로 만들기 위해 *5 함

// ref31=  adresult[3];  // NC

ref211 =  adresult[2];  // FP2 ,Tp2 2차 amp 출력 값,

ref11 =  adresult[1];  // SPL for voice , NC

ref01 =  adresult[0];  // SVR ,NC

}

tp2 = (ref21 + ref211 ) / 2 ; // 실시간 tp2 값


if ((ref21 - 10) >= adresult[2]) // 먼저 값보다 현재 값이 작으면 감지 사라짐 의미

{
Stdby1 = adresult[2] ;
Stdby = (Stdby0 + Stdby1) / 2 ;
}

else
{
tp2 = adresult[2] ;

}

if ( tp2 >= (Stdby + 10))
{
DV = tp2 - Stdby ;

}

else
{
DV = 0 ;
PORTB = 0b11111110 ; // Yel LED 만 on
}

ISeg7DispNum (tp2,10) ; // 실시간 값


if ( DV >= 80)
{
PORTB = 0b00000001 ;
}

else if ( DV >= 40)
{
PORTB = 0b10000001 ;
}

else if ( DV >= 20)
{
PORTB = 0b11000001 ;
}

else if ( DV >= 10)
{
PORTB = 0b11100001 ;
}

else
{
PORTB = 0b11111110 ; //10 이하일대 PB3 은 LOW
}

msec_delay(800) ;	// 50ms 지연

}
return 0 ;
}

void msec_delay (int n)
{
for (; n>0; n--)
_delay_ms(1);  // 시간 지연하려면 (2)로 한다//TODO:: Please write your application code
}

//end

