/*
 * atmega128_sensor_voice.c
 *
 * Created: 2019-04-16 오후 2:45:11
 *  Author: 강건일
 * LCD 는 주파수 표기
 * LED는 신호 크기 표기
 *  Pin 61 PF0=  PB4 = Yellow,
 Pin 60 PF1=  PB5 = RED
 Pin 59 PF2 = PB6 = GRN
 Pin 58 PF3=  PB7 = Blue
 공개용: 103 삭제, Jtag 삭제, 16MHZ 4ms
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>
#include <math.h> // 추가

#include "lcdh.cpp"
#include "lcd.c"
#include "button123.cpp"
#include "button switch123.c"
#include "iseg7.cpp"
#include "iseg7 source.c"

void msec_delay(int n); //20
#define  CPU_CLOCK_KHZ   16000UL
#define   PRESCALE        256UL

#define  N_CHANNEL   4 //from 4
#define Reading  5 // 190327 4번읽기 할때 5임(4+1)
static int i; //190327
static int k; //190327


static volatile unsigned short timer;
static volatile unsigned short n_pulse=0;


ISR (TIMER1_COMPA_vect)
{
	OCR1A += timer;
	
	n_pulse = TCNT3;
	TCNT3 = 0x00;  //33
	
}
 
 void msec_delay (int n);
 
int main()

{
	 int adresult[N_CHANNEL];           // 처리 속도 개선
	 int i;
	 int k;
	 long int ref0,ref1,ref2,ref3,ref10,ref11,ref12,ref13,ref20,ref21,ref22,ref23,ref30,ref31,ref32,ref33,ref100,ref101,ref102,ref103 ; // 변수 추가, ref 는 기준값 변수
	 
	 DDRA = 0xFF; //PORT A 를 출력 포트
	 DDRB = 0xFF; // PORT B를 출력 포트
	 
	 DDRD = 0xF0; // PORT D  출력 포트
	 
	 PORTA = 0x00; //seg L= on
	 PORTD = 0xF0; //digit L =on
	 
	 //TCCR0 = 0x00;  //표준모드 타이머 정지
	 //TCNT0 = 100;   //타이머 초기값 설정
	 
	 //TIMSK = (1<<TOIE0) ; //타이머 0 오버플로 인터럽트 허용
	 //sei();               // 전역 인터럽트 허용
	 //TCCR0 |=(7<<CS00);   //7일때 분주비 1024로 타이버 시작, 6이면 256으로 분주되나 약 5초후 1024형태로 오동작
	 
	 // LED TEST , PWR 인가 후 안정될 때까지 LED TEST	,10000= 0.3초
	 
	 PORTB = 0x0F; // all on
	 msec_delay(1000);
	 PORTB = 0xEF; // PB4, Yellow
	 msec_delay(1000);
	 PORTB = 0xDF; // PB5 Red
	 msec_delay(1000);
	 PORTB = 0xBF; // PB6 Grn
	 msec_delay(1000);
	 PORTB = 0x7F; // PB7 , Blue
	 msec_delay(1000);
	 PORTB = 0x0F; // all on
	 msec_delay(1000);
	 
	 PORTB = 0xFF; //all off
	 PORTD = 0x00; //all low
	 
	 sei ();
	 ISeg7Init();
	 
	 ADCSRA = (1<<ADEN) | (7<<ADPS0) ;//  프리스켈러 분주 = 128, smpling rate=> 16MHz / 128 = 125 KHz  /13 clock =9.6KHz	 
	
	
	unsigned short ts=500;
	unsigned short pulse, timer1;   //41
	unsigned short hz;
	unsigned short in, string[10];
	
	//장치 초기화
	BtnInit ();
	LcdInit();
	ISeg7Init();
	
	LcdMove(0,0);         LcdPuts("Meas(msec):");
	LcdMove(1,0);         LcdPuts("Freq.(hz)");
	
	timer = (unsigned short)  (ts*CPU_CLOCK_KHZ/PRESCALE);
	
	sprintf(string,"%4u",ts);
	LcdMove(0,11); LcdPuts(string); //56
	
	TCCR1A = (1<<COM1A0);
	//DDRB |= (1<<DDB5); //DDB5 처음 사용으로 error 발생
	DDRB |= (1<<PB5);
	TCCR1B = 0x00;
	TIMSK |= (1<<OCIE1A); //61
	
	TCCR3A = 0x00;
	TCCR3B = 0x00;
	sei();   //65
	TCCR1B |= (4<<CS10);
	TCCR3B |= (7<<CS30);
	
	while(1)
	{
		PORTB = 0xFF ; //상위4bit led 모두 off
		
		//data += 10; // 10에서 1로 변경 10은 10자리부터 시작되고 1은 첫 자리부터 시작.
		
		for (k = 0; k<Reading ;k++)
		
		{
			
			for ( i=0; i<N_CHANNEL;i++)
			{
				ADMUX = (1<<REFS0) | (i<<MUX0);  // 내부2.56v 일때3 그리고 5v일때는 1임, .
				//실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨
				
				ADCSRA |= (1<<ADSC); // AD 변환 시작
				
				while(!(ADCSRA & (1<<ADIF))); //변환 종료를 기다림
				
				ADCSRA |= (1<<ADIF); // ADIF 플레그 지움
				adresult[i] = ADC;
				
				adresult[i] = adresult[i] * 5 ;         //실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
				//이것을 실제 전압 mv로 만들기 위해 *5 함
				
				ref3=  adresult[3];  // FP3 gnd, GRN Led PB6
				
				ref2=  adresult[2];  // FP2 , 2차 amp 출력 값, RED Led PB5
				
				ref1=  adresult[1];  // FP1 ,  1차 amp 출력 값, blue Led PB7
				
				ref0=  adresult[0];  // FP0, thg , gnd, yellow LED PB4
				
				
				
			}
			if (k==1)
			ref0 = adresult[0], ref1 = adresult[1], ref2 = adresult[2], ref3 = adresult[3], PORTB = 0xEF,
			msec_delay(60) ; //yel 4ms on = Low, 17ms 주기로 low 됨
			
			if (k==2)
			ref10 = adresult[0], ref11 = adresult[1], ref12 = adresult[2], ref13 = adresult[3], PORTB = 0xDF,
			msec_delay(60) ;// red 4ms on
			
			if (k==3)
			ref20 = adresult[0], ref21 = adresult[1], ref22 = adresult[2], ref23 = adresult[3],PORTB = 0xBF,
			msec_delay(60) ;// grn 4ms on
			
			if (k==4)
			ref30 = adresult[0], ref31 = adresult[1], ref32 = adresult[2], ref33 = adresult[3], PORTB = 0x7F,
			msec_delay(60) ; //blue 4ms on
			
			ref100 = (ref0 + ref10 + ref20 + ref30) /4 ; //4ms 간격으로 4번 읽어서 평균. Voice_OUT & Bias
			ref101 = (ref1 + ref11 + ref21 + ref31) /4 ; // Voice_OUT DC 값
			ref102 = (ref2 + ref12 + ref22 + ref32) /4 ; // Body_OUTPUT
			ref103 = (ref3 + ref13 + ref23 + ref33) /4 ; // Thermistor OUT, Thg
			
		}
		
	//	ISeg7DispNum (ref100,10); // ac를 바로 읽을때, 값이 수시로 변한다.
	//	PORTB = 0xEF ; //yel on , Voice_OUT AC LEVEL
	//	msec_delay(18500); //18500 이 1200ms 정도 임
		//ref101 = ref101 + 100 ; // 뺄셈에서 리플 마이너스 보상 , svr 삭제하고 바이어스 없앤다
		//ref101 = (ref101 - ref100) ; // 직류 바이어스값을 뺀다.
		//ref101 = ref101 -100 ;
		
		ISeg7DispNum (ref101,10); // Red on, Voice_ DC OUTPUT
	//	PORTB = 0xDF ; //red on
		msec_delay(10);
		
	//	ISeg7DispNum (ref102,10); // Grn on, Body Detection_ Output
	//	PORTB = 0xBF ; //GRN on
	//	msec_delay(18500);
		
	//	ISeg7DispNum (ref103,10); // Blu on, Thermistor Output
	//	PORTB = 0x7F ; //blu on
	//	msec_delay(18500);
		
		switch((in=BtnInput()))
		{
			case  BTN_SW0: // int0 PD0, active low 일때 500 부터 50 씩 커짐
			ts += 50;
			break;
			
		//	case BTN_SW1:  // int1 pd1, active low 일때 500부터 50 씩 감소, pcb pattern 에서 PG0 PG1 PG2 노이즈 유기시 오동작. pull up 필요		
		//	ts -= 50;
		//	break;
		}
		if(ts >= 1000) ts=1000;
		if(ts <= 50) ts = 50;
		
		timer1 = (unsigned short) (ts*CPU_CLOCK_KHZ/PRESCALE);
		
		cli();
		timer = timer1;
		pulse = n_pulse;
		sei();
		
		sprintf(string,"%4u",ts);
		LcdMove(0,11);    LcdPuts(string);
		
		hz = (unsigned short)  (pulse*1000UL/ts);
		sprintf(string, "%5u",hz);
		LcdMove(1,11);     LcdPuts(string);
		
	//	ISeg7DispNum(pulse,10); // lcd 는 주파수와 주기표기, led display 는 level 표기
		
	}
}
void msec_delay(int n)

{
	for (; n>0; n--)
	_delay_ms(10);
}


