﻿/*
 * iseg7_source.c
 *
 * Created: 2013-01-11 오후 2:48:36
 *  Author: 강건일
 */ 



#include <avr/io.h>
#include <util/delay.h>

#include "iseg7.cpp"      //7세그 구동 헤더화일   호출하는 화일과 같이 있으면 "" 사용하고 아니면 <> 사용

#define N_BUF        5  //수 저장할 버퍼 수
#define N_SEGMENT    4  //7 seg 갯수
#define SSEG_CONT    PORTD  //seg 제어 포트
#define DDR_CONT     DDRD
#define SSEG_DATA    PORTA   //7seg data port
#define DDR_DATA     DDRA

#define CONT_MASK  ((1<<PD7) | (1<<PD6) | (1<<PD5) | (1<<PD4))
//제어 포트로 사용하는 포트 마스크
#define OUTPUT_VALUE  (1<<PD4)   //제어 포트중 최하위 비트로 설정


//수에 대한 7 세그먼트 코드
//마지막 코드 segtable[16]은 세그먼트를 끄는데 사용

static unsigned char SegTable[17]  //코드값
     = {0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 
	  0x7F, 0x6F, 0x77, 0x7C, 0x58, 0x5E, 0x79, 0x71,
	   0x00};
	  
	  
	  
// cnumber[0] :1자리수 저장
// cnumber[1] :10자리수 저장
//-------------------------------------------------
static unsigned char cnumber[N_BUF]={16,16,16,16,16};


//제어 초기화


void ISeg7Init()
{
	
	SSEG_CONT |= CONT_MASK;   //모든 세그 끈다
	
	DDR_CONT |= CONT_MASK;    //상위 니블출력 설정
	DDR_DATA = 0xFF;          //모두 출력 설정


TCCR0 = (1<<WGM01);    //CTC 모드 설정
OCR0 = 78;  //5ms 마다 비교 일치 인터럽 발생
TIMSK |= (1<<OCIE0) ;
TCCR0 |= 0X07 ; //분주비1024 
}

//2바이트 부호없는 정수를 받아 주어진 진법으로 네자리	
//7- 세그먼트에 동적으로 표시하는 함수
// 입력 : num   -7-세그먼트에 표시할 수
// radix - 사용 진법

void ISeg7DispNum (unsigned short num, unsigned short radix)
{
	int j;
	//cnumber[]에 수 0 저장
	//cnumber[0] = 0
	//cnumber[1] ~ cnumber[N_BUF-1] = 16:세그먼트를 끈다
	
	TIMSK &= ~(1<<OCIE0);
	
	cnumber[0] = 0;
	for (j=1; j<N_BUF; j++) cnumber[j] = 16;
	
	j=0;        //1자리를 가리킴
	while (num)
	{
		cnumber[j++] = num % radix;  //나머지
		num /= radix;                 // 몫
	}
	
	TIMSK |= (1<<OCIE0);
   }	
	
	
	
	ISR (TIMER0_COMP_vect)
	
	{
	 static int index = 0;
	 	
	SSEG_CONT = ( SSEG_CONT & ~CONT_MASK) |
	            (~(OUTPUT_VALUE<<index) & CONT_MASK) ;  
	SSEG_DATA = ~SegTable[cnumber[index]];//97 line
	
	//_delay_ms (5);  // 5ms delay
	
	index++;
	if (index == N_SEGMENT)  index = 0;
	}




